import {Injectable} from '@angular/core';
import {Http, Response, Headers} from '@angular/http';
import {Observable} from 'rxjs/observable';
import 'rxjs/add/operator/map';

@Injectable()
export class HttpService {
  passHeader = new Headers();

  constructor(private http: Http) {
    this.passHeader.append('Access-Control-Allow-Credentials', 'true');
    this.passHeader.append('Access-Control-Allow-Origin', '*');
    this.passHeader.append('Access-Control-Allow-Methods', 'PUT,POST,GET,DELETE,OPTIONS');
    this.passHeader.append('Content-Type', 'application/json;charset=utf-8');
  }

  getData(conf) {
    return this.requestFn('get', conf);
  }

  postData(conf) {
    return this.requestFn('post', conf);
  }

  private requestFn(method, conf): Observable<Response> {
    const url = conf.url ;
    let data = conf.data;
    let options = {
      headers: this.passHeader,
      search: conf.search || {},
    };
    if (!data) {
      data = options;
      options = null;
    }
    return this.http[method](url, data, options).map((responese: Response) => {
      const res = responese.json();
      if (!res || res.status !== 'success') {
        throw res;
      }
      return res;
    });
  }
}
