import {Component, ElementRef, HostListener, Input, OnInit, ViewChild} from '@angular/core';

@Component({
  selector: 'dc-select',
  templateUrl: './select.component.html',
  styleUrls: ['./select.component.css']
})
export class SelectComponent implements OnInit {
  @Input() options;
  @Input() defaultSelect;
  @Input() isReadonly;
  @ViewChild('moreOption') moreOption: ElementRef;

  constructor() {

  }

  ngOnInit() {
    if (!this.options) {
      this.options = [
        {
          id: 1,
          name: 'a1',
        }, {
          id: 2,
          name: 'a2'
        }, {
          id: 3,
          name: 'a3'
        }, {
          id: 4,
          name: 'a4'
        }
      ];
    }
    if (!this.defaultSelect) {
      this.defaultSelect = this.options[0];
    }
  }

  @HostListener('document:click', ['$event'])
  onDocumentClick(ev) {
    this.moreOption.nativeElement.style.display = 'none';
  }

  showOption(ev) {
    ev.stopPropagation();
    ev.preventDefault();
    this.moreOption.nativeElement.style.display = 'block';
  }

  changeItem(item) {
    if (this.defaultSelect && this.defaultSelect.id === item.id) {
      return;
    }
    this.defaultSelect = item;
  }
}
