import {
  Component,
  Input,
  OnInit,
  Output,
  EventEmitter,
  OnChanges,
  SimpleChanges,
  ViewChild,
  ViewContainerRef,
  ComponentFactoryResolver
} from '@angular/core';
import {Router, NavigationStart, NavigationEnd, NavigationCancel, NavigationError, RoutesRecognized} from '@angular/router';

@Component({
  selector: 'dc-tab',
  templateUrl: './tab.component.html',
  styleUrls: ['./tab.component.css', '../plugin.css']
})
export class TabComponent implements OnInit {
  _tabDatas;
  @Input() set tabDatas(v) {
    this._tabDatas = v;
    this.init();
  }

  get tabDatas() {
    return this._tabDatas;
  }

  ref;
  @Output() tabChangeEvent = new EventEmitter();
  nowSelectTab;
  @ViewChild('dyComponent', {read: ViewContainerRef}) dyComponent: ViewContainerRef;

  constructor(private resolver: ComponentFactoryResolver, private router: Router) {

  }

  ngOnInit(): void {
  }

  init() {
    if (this.tabDatas == null && this.tabDatas.length == 0) {
      this.dyComponent.clear();
      return;
    }
    this.dyComponent.clear();
    for (let tab of this.tabDatas) {
      if (tab.select) {
        this.nowSelectTab = tab;
      }
    }

    if (this.nowSelectTab == null) {
      this.nowSelectTab = this.tabDatas[0];
    }

    if (this.nowSelectTab.component) {
      let component = this.resolver.resolveComponentFactory(this.nowSelectTab.component);
      this.ref = this.dyComponent.createComponent(component);
      if (this.nowSelectTab.data) {
        let instance = this.ref.instance;
        instance.data = this.nowSelectTab.data;
      }
    }

    if (this.nowSelectTab.url) {
      let params = this.nowSelectTab.params == null ? {} : this.nowSelectTab.params;
      this.router.navigate([this.nowSelectTab.url], {queryParams: params});
    }


  }

  /*  ngOnChanges(changes: SimpleChanges) {
	  if (changes.tabDatas && !changes.tabDatas.firstChange) {
		this.init();
	  }
	}*/

  changeTab(tab) {
    for (let d of this.tabDatas) {
      d.select = false;
    }
    tab.select = true;
    this.nowSelectTab = tab;
    this.init();
    this.tabChangeEvent.emit(tab);
  }
}
